/*
 * Copyright (c) 1995-1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */
import java.util.ListResourceBundle;
import java.util.Locale;

public abstract class SoundBundle extends ListResourceBundle {

    Object[][] contents;
    String soundNames[] = { "book", "car", "dog", "apple" };

    public SoundBundle(Locale myLocale) {

	String localeName = myLocale.toString();

        contents = new Object[soundNames.length][2];

	for (int i = 0; i < soundNames.length; i++) {
	    contents[i][0] = soundNames[i];
	    contents[i][1] = soundNames[i] + "_" + localeName + ".au";
	}
    }

    public Object[][] getContents() {
        return contents;
    }
}
