/*
 * Copyright (c) 1995-1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */
import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import com.sun.java.swing.AbstractButton;
import com.sun.java.swing.JButton;
import com.sun.java.swing.JPanel;
import com.sun.java.swing.JFrame;
import com.sun.java.swing.ImageGlyph;

/**
 * This would have been a simple wrapper around ButtonDemo, if not
 * for the fact that you apparently can't load images in Swing-based
 * applets (due to security limitations in the implementation).
 *
 * So instead, this applet duplicates ButtonDemo, omitting the code
 * that creates images in the buttons.
 */
public class AppletDemo extends Applet
                        implements java.awt.event.ActionListener {

JButton b1, b2, b3;

    public void init() {
	//ImageGlyph leftButtonGlyph = new ImageGlyph("right.gif");
	//ImageGlyph middleButtonGlyph = new ImageGlyph("middle.gif");
	//ImageGlyph rightButtonGlyph = new ImageGlyph("left.gif");

        //b1 = new JButton("Disable middle button", leftButtonGlyph);
        b1 = new JButton("Disable middle button");
	b1.setVerticalTextPosition(AbstractButton.CENTER);
	b1.setHorizontalTextPosition(AbstractButton.LEFT);
	b1.setKeyAccelerator('d');
	b1.setActionCommand("disable");

        //b2 = new JButton("Middle button", middleButtonGlyph);
        b2 = new JButton("Middle button");
	b2.setVerticalTextPosition(AbstractButton.BOTTOM);
	b2.setHorizontalTextPosition(AbstractButton.CENTER);
	b2.setKeyAccelerator('m');

        //b3 = new JButton("Enable middle button", rightButtonGlyph);
        b3 = new JButton("Enable middle button");
	//Use the default text position of CENTER, RIGHT.
	b3.setKeyAccelerator('e');
	b3.setActionCommand("enable");
        b3.setEnabled(false);

	//Listen for actions on buttons 1 and 3.
	b1.addActionListener(this);
	b3.addActionListener(this);

        //Add Components to the JPanel, using the default FlowLayout. 
        add(b1);
        add(b2);
        add(b3);
    }

    public void actionPerformed(java.awt.event.ActionEvent e) {
        if (e.getActionCommand().equals("disable")) {
            b2.setEnabled(false);
            b1.setEnabled(false);
            b3.setEnabled(true);
        } else { 
            b2.setEnabled(true);
            b1.setEnabled(true);
            b3.setEnabled(false);
        }
    }
    
    public static void main(String[] args) {
	/*
	 * Create a window.  Use JFrame since this window will include 
	 * lightweight components.
	 */
	JFrame frame = new JFrame("AppletDemo");

	WindowListener l = new WindowAdapter() {
	    public void windowClosing(WindowEvent e) {System.exit(0);}
	};
	frame.addWindowListener(l);

	AppletDemo applet = new AppletDemo();
	applet.init();
	frame.add("Center", applet);
	frame.pack();
	frame.show();
    }
}


